#!/bin/bash
SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" &> /dev/null && pwd )"
cd "$SCRIPT_DIR"

FILE=player.txt
DIR=graphics/render

LETTER=(A B C D E F G H I J K L M N O P Q R S T U V W X Y Z)
ROTATE=(1 2 3 4 5 6 7 8 9 A B C D E F G)
NUMBER=(1 3 5 7 9 11 13 15 2 4 6 8 10 12 14 16)
SPRITE="QPR"
SIZE="192, 188"
OFFSET="96, 158"

NUM1=1
NUM2=1
LMOD=0
RMOD=0
IDXA=0
IDXB=0
LS=$(ls *.png)
COUNT=$(wc -l <<< $LS)
rm player.txt 2>/dev/null
touch $FILE
echo "// player" >> $FILE
echo "" >> $FILE
for f in $LS; do
	echo -en $((100 * $NUM1 / $COUNT))%

	echo "Sprite \"$SPRITE$NUM2${LETTER[$LMOD]}${ROTATE[$RMOD]}\", $SIZE {" >> $FILE
	echo "	XScale 2.000" >> $FILE
	echo "	YScale 2.000" >> $FILE
	echo "	Offset $OFFSET" >> $FILE
	echo "	Patch \"$DIR/player/player_"$(printf "%03d" $(($IDXA + 1)))"_"$(printf "%02d" ${NUMBER[$(($IDXB))]})".png\", 0, 0" >> $FILE
	echo "}" >> $FILE
	echo "" >> $FILE

	RMOD=$(($NUM1 % 16))
	IDXB=$((($IDXB + 1) % 16))
	if [ $RMOD == 0 ]; then
		LMOD=$((($LMOD + 1) % 26))
		IDXA=$(($IDXA + 1))
	fi
	if [ $RMOD == 0 ] && [ $LMOD == 0 ]; then
		NUM2=$(($NUM2 + 1))
	fi
	NUM1=$(($NUM1 + 1))
	echo -en "\r"
done